"""
    Nomad Broker

    Nomad payment provider aggregation, including make payments, and customs declaration for orders and etc.  # noqa: E501

    The version of the OpenAPI document: 1.5.1
    Contact: ben.song@samarkand.global
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

import nulltype  # noqa: F401

from nomad_broker_cli.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)


class CustomsPaymentOrder(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'state': (str, none_type,),  # noqa: E501
            'sub_order_no': (str, none_type,),  # noqa: E501
            'sub_order_id': (str, none_type,),  # noqa: E501
            'mch_customs_no': (str,),  # noqa: E501
            'explanation': (str,),  # noqa: E501
            'customs': (str,),  # noqa: E501
            'modify_time': (str, none_type,),  # noqa: E501
            'duty': (int,),  # noqa: E501
            'fee_type': (str,),  # noqa: E501
            'order_fee': (int,),  # noqa: E501
            'transport_fee': (int,),  # noqa: E501
            'product_fee': (int,),  # noqa: E501
            'cert_type': (str,),  # noqa: E501
            'cert_check_result': (str, none_type,),  # noqa: E501
            'verify_department': (str, none_type,),  # noqa: E501
            'verify_department_trade_id': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'state': 'state',  # noqa: E501
        'sub_order_no': 'subOrderNo',  # noqa: E501
        'sub_order_id': 'subOrderId',  # noqa: E501
        'mch_customs_no': 'mchCustomsNo',  # noqa: E501
        'explanation': 'explanation',  # noqa: E501
        'customs': 'customs',  # noqa: E501
        'modify_time': 'modifyTime',  # noqa: E501
        'duty': 'duty',  # noqa: E501
        'fee_type': 'feeType',  # noqa: E501
        'order_fee': 'orderFee',  # noqa: E501
        'transport_fee': 'transportFee',  # noqa: E501
        'product_fee': 'productFee',  # noqa: E501
        'cert_type': 'certType',  # noqa: E501
        'cert_check_result': 'certCheckResult',  # noqa: E501
        'verify_department': 'verifyDepartment',  # noqa: E501
        'verify_department_trade_id': 'verifyDepartmentTradeId',  # noqa: E501
    }

    _composed_schemas = {}

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """CustomsPaymentOrder - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            state (str, none_type): Status code, UNDECLARED: not declared (If the order has been sent to the customs, the merchant resubmits and the customs still has the modification interface); PROCESSING: reporting; SUCCESS: Declaration is successful; FAIL: failed to declare; EXCEPT: The customs interface is abnormal. [optional]  # noqa: E501
            sub_order_no (str, none_type): The internal order number of the merchant system. [optional]  # noqa: E501
            sub_order_id (str, none_type): Transaction ID returned by payment company. [optional]  # noqa: E501
            mch_customs_no (str): The merchant’s record number registered in the customs. [optional]  # noqa: E501
            explanation (str): The declaration result indicates that if the status is failed or abnormal, the failure reason is displayed. [optional]  # noqa: E501
            customs (str): Customs code. [optional]  # noqa: E501
            modify_time (str, none_type): The last update time, time zone is GMT+8 beijing. [optional]  # noqa: E501
            duty (int): Tariff, divided into units. [optional]  # noqa: E501
            fee_type (str): The currency used for payment of payment company orders is currently only supported in RMB CNY. If there is an order split, it must be sent.. [optional] if omitted the server will use the default value of "CNY"  # noqa: E501
            order_fee (int): The amount of the sub-order, in cents, cannot exceed the amount of the original order, order_fee=transport_fee+product_fee (amount payable = logistics fee + product price), if there is a split order, it must be passed.. [optional]  # noqa: E501
            transport_fee (int): The logistics cost is divided into units, and must be passed if there is a split order.. [optional]  # noqa: E501
            product_fee (int): Commodity costs, in units of cents, must be passed if there is a split order.. [optional]  # noqa: E501
            cert_type (str): Only mainland ID cards are supported temporarily.. [optional] if omitted the server will use the default value of "IDCARD"  # noqa: E501
            cert_check_result (str, none_type): UNCHECKED: did not check the identity information of the order; SAME: consistent with the identity information of the payer; DIFFERENT: inconsistent with the identity information of the payer. [optional]  # noqa: E501
            verify_department (str, none_type): The verification agencies. [optional]  # noqa: E501
            verify_department_trade_id (str): Transaction serial number, from the verification agency, such as the transaction serial number recorded by UnionPay, for merchants to report to the customs. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
